%define name roxen
%define version 1.3.122
%define release 4mdk

Name: %{name} 
Summary: Roxen is a powerfull and easy to adminstrate webserver 
Version: %{version}
Release: %{release}
Source0: http://www.roxen.com/download/source/roxen_1.3.122-0.6-40bit.tar.bz2
Source1: Global_Variables
Source2: configuration.template
Source3: initd.template
Source4: frontend1.gif
Source5: frontend2.gif
Source6: mandrake.gif
Source7: redhat.gif
Source8: index.html.template
Patch0: ftp://ftp.roxen.com/pub/roxen/patches/roxen_1.3.122-wizard.pike.patch
Group: System/Servers
URL: http://www.ls-la.net/roxen/
BuildRoot: /var/tmp/%{name}-buildroot
Copyright: GPL
Packager: Oliver Schade <os@ls-la.net>
Prefix: /usr

%description
Roxen is a webserver, based at the language Pike. It offers full administration
using a WWW-interface, SSL-support, adding/deleting/updating of internal mo-
dules without recompiling, shutdown/restart without superuser-privileges and a 
lot of usefull additional modules like Email-frontends, generation of GIFs,
diagrams, counter etc. Once you use it, you will love it.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n roxen_1.3.122

# Patching wizard.pike - Patch0
cd server/base_server
%patch0 

%build
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure \
	--prefix=%{prefix}
make

%install
make install prefix=$RPM_BUILD_ROOT/%{prefix}

# Define some directories
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/var/log/roxen
mkdir -p $RPM_BUILD_ROOT/etc/roxen
mkdir -p $RPM_BUILD_ROOT/home/roxen/html
mkdir -p $RPM_BUILD_ROOT/home/roxen/cgi-bin
mkdir -p $RPM_BUILD_ROOT/usr/doc/roxen-1.3.122/pdf
mkdir -p $RPM_BUILD_ROOT/usr/doc/roxen-1.3.122/html
mkdir -p $RPM_BUILD_ROOT/home/roxen/html/welcome

# Set up logging-directory
cd $RPM_BUILD_ROOT%{prefix}/roxen
rmdir logs
ln -s /var/log/roxen logs
cd $RPM_BUILD_ROOT/etc/roxen
ln -s /var/log/roxen logs

# Set up configuration-directory
mv -f $RPM_BUILD_ROOT%{prefix}/roxen/configurations \
	$RPM_BUILD_ROOT/etc/roxen/configurations
cd $RPM_BUILD_ROOT%{prefix}/roxen/server
ln -s /etc/roxen/configurations configurations

# Install PDF-documentation
mv -f $RPM_BUILD_ROOT%{prefix}/roxen/server/manual/pdf/* \
	$RPM_BUILD_ROOT/usr/doc/roxen-1.3.122/pdf
# Install HTML-documentation
mv -f $RPM_BUILD_ROOT%{prefix}/roxen/server/manual/parsed_challenger/* \
	$RPM_BUILD_ROOT/usr/doc/roxen-1.3.122/html
# Delete the unwanted stuff to save disk-space
rm -rf $RPM_BUILD_ROOT%{prefix}/roxen/server/manual

# Init.d-script
cp -f %{SOURCE3}     $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen
#chown root:root      $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen
chmod u=rwx,g=rx,o=r $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen

# Install welcome-HTML-page including graphics
cp -f %{SOURCE4}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE5}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE6}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE7}     $RPM_BUILD_ROOT/home/roxen/html/welcome/
#chown root:root      $RPM_BUILD_ROOT/home/roxen/html/welcome/*
chmod u=rw,g=r,o=r   $RPM_BUILD_ROOT/home/roxen/html/welcome/*

# To include the templates :(
cp -f %{SOURCE1} \
	$RPM_BUILD_ROOT/etc/roxen/configurations/Global_Variables.template
cp -f %{SOURCE2} \
	$RPM_BUILD_ROOT/etc/roxen/configurations/Host.template
cp -f %{SOURCE8} \
    $RPM_BUILD_ROOT/etc/roxen/index.html.template

# Make the Roxen-Starter easier to find in ps
cd $RPM_BUILD_ROOT%{prefix}/roxen/server
ln start RunRoxen

if [ -d $RPM_BUILD_ROOT/usr/man ]; then
  find $RPM_BUILD_ROOT/usr/man -type f -exec bzip2 -9f {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/info ]; then
  find $RPM_BUILD_ROOT/usr/info -type f -exec bzip2 -9f {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/X11R6/man ]; then
  find $RPM_BUILD_ROOT/usr/X11R6/man -type f -exec bzip2 -9f {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/lib/perl5/man ]; then
  find $RPM_BUILD_ROOT/usr/lib/perl5/man -type f -exec bzip2 -9f {} \;
fi

if [ -d $RPM_BUILD_ROOT/usr/bin ]; then
  find $RPM_BUILD_ROOT/usr/bin -type f -exec strip {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/roxen/server/bin ]; then
  find $RPM_BUILD_ROOT/usr/roxen/server/bin -type f -exec strip {} \;
fi

# Correct #!/usr/local/bin/pike lines to get dependencies working :(
find $RPM_BUILD_ROOT -type f -exec /usr/bin/perl -p -i -e  \
      's/\#\!\/usr\/local\/bin\/pike/\#\!\/usr\/bin\/pike-roxen/' {} \;
# Correct 'Roxen's install prefix' within pike-roxen
cat $RPM_BUILD_ROOT/usr/bin/pike-roxen | \
	sed -e "s/\/var\/tmp\/roxen-buildroot\/\/usr\/roxen\/server\//\/usr\/roxen\/server\//" \
	> $RPM_BUILD_ROOT/usr/bin/pike-roxen.new
mv -f $RPM_BUILD_ROOT/usr/bin/pike-roxen.new $RPM_BUILD_ROOT/usr/bin/pike-roxen

cd $RPM_BUILD_ROOT
# First, remove TAGS files, otherwise spec-helper will make troubles

find . -type f -name "TAGS" -exec /bin/rm -f '{}' \;

find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
	$RPM_BUILD_DIR/file.list.%{name}

find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
       -e '/\/etc\//s|^|%config|' \
       -e '/\/config\//s|^|%config|' \
       >> $RPM_BUILD_DIR/file.list.%{name}

find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
	$RPM_BUILD_DIR/file.list.%{name}

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}

%files -f ../file.list.%{name}
%defattr(-,root,root,0755)

%preun
if [ $1 -eq 0 ]; then	# We're running "rpm -e"
	if [ -x /etc/rc.d/init.d/roxen ]; then
		/etc/rc.d/init.d/roxen stop;
		chkconfig --del roxen;
	fi
	rm -f /etc/rc.d/init.d/roxen;
	rm -rf /var/log/roxen/*;
	rm -rf /etc/roxen;
fi

%post
if [ $1 -eq 1 ]; then	# We're running "rpm -i"
	# Short hint for Admin
	echo "Use https://"`hostname`":13122/ for the administration-interface" > \
		/usr/doc/roxen-1.3.122/readme.txt
	echo "Use http://"`hostname`"/doc/ for manuales" >> \
		/usr/doc/roxen-1.3.122/readme.txt
	echo "Or use the PDF-documents within /usr/doc/roxen-1.3.122/" >> \
		/usr/doc/roxen-1.3.122/readme.txt

    # Install welcome-HTML-page
    cat /etc/roxen/index.html.template \
        | sed -e "s/%HOST%/`hostname`/g" \
        > /home/roxen/html/index.html

	# Install a basic configuration
	cat /etc/roxen/configurations/Global_Variables.template \
		| sed -e "s/%HOST%/`hostname`/g" \
		> /etc/roxen/configurations/Global_Variables
	chmod u=rw,g=r,o= \
		/etc/roxen/configurations/Global_Variables

	cat /etc/roxen/configurations/Host.template \
		| sed -e "s/%HOST%/`hostname`/g" \
		> /etc/roxen/configurations/`hostname`
	chmod u=rw,g=r,o= \
		/etc/roxen/configurations/`hostname`

    # Delete templates
	rm -f /etc/roxen/configurations/*.template

    # Add Roxen in according Runlevels
	chkconfig --add roxen

elif [ $1 -gt 1 ]; then	# We're running "rpm -U"
	/etc/rc.d/init.d/roxen status 2>&1 > /dev/null
	if [ $? -eq 0]; then
		/etc/rc.d/init.d/roxen restart
	fi
fi

%changelog
* Wed Apr 19 2000 dam's <dam's@mandrakesoft.com> 1.3.122-4mdk
- changed icon


* Tue Mar 28 2000 Pixel <pixel@mandrakesoft.com> 1.3.122-3mdk
- new group
- rebuild for new readline

* Wed Mar 22 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Adapted to the new Group structure
- Fixed the rpm with respect to the new spec-helper script

* Wed Jan 19 2000 Lenny Cartier <lenny@mandrakesoft.com>
- v 1.3.122
- used srpm provided by Oliver Schade <os@ls-la.net>

* Mon Jan 03 2000 Oliver Schade <os@ls-la.net>
- Added patch for wizard.pike, now handles IE better

* Mon Dec 20 1999 Oliver Schade <os@ls-la.net>
- Updated to new Roxen 1.3rel3 (1.3.122)
- Configuration Port moved to 13122

* Sat Dec 18 1999 Oliver Schade <os@ls-la.net>
- Added a welcome-page demonstrating the major advantages of Roxen

* Mon Nov 29 1999 Lenny Cartier <lenny@mandrakesoft.com>
- New in contribs
- bz2 archive

* Mon Oct 18 1999 Oliver Schade <os@ls-la.net>
- Ooops, the spec-file did not included the templates :-((

* Sun Oct 17 1999 Oliver Schade <os@ls-la.net>
- Enabled cgi-bin-module (Ooooops)

* Sat Oct 16 1999 Oliver Schade <os@ls-la.net>
- Changed prefix from /usr/roxen -> /usr
- Added striping of roxen/server/bin
- Changing of roxen_prefix within pike-roxen added

* Fri Oct 15 1999 Oliver Schade <os@ls-la.net>
- Updated to new Roxen-1.3r2 (1.3.121) release
- Deleted modifcations and CVS-specific compile-instructions.
- HTML- and PDF-documentation moved to /usr/doc/roxen-X.X.XXX
- make -j2 does not work again
- Used %preun and %post from Stefan Siegel <siegel@informatik.uni-kl.de>

* Sat Oct 09 1999 Oliver Schade <os@ls-la.net>
- Included both PDF- and HTML-documentation
- Added preconfigured 'Global-Variables'
- Added welcome-page using some of Roxen's featues.

* Sat Oct 02 1999 Oliver Schade <os@ls-la.net>
- Build a source-package based on CVS-versions
- Modified spec-file after failed experiments
- make -j2 works with CVS-tree

* Wed Sep 22 1999 Oliver Schade <os@ls-la.net>
- First spec-file, just compiles anything
  Do not use 'make -j x', it would not work!
